\chapter{Basics of XMPP}
\label{chap:basics}

\acrshort{XMPP} is an open, \acrshort{XML}-based protocol for near real-time messaging,
presence,
and request-response services.
\acrshort{XMPP} is short for \acrlong{XMPP}.
Its key features are visible in the abbreviation itself:

\begin{description}
 \item \emph{eXtensible}\\ The protocol is designed to be extensible in order to meet future requirements.
 \glspl{XEP} are explained in \cref{sec:xeps}.
 \item \emph{Messaging}\\ Entities exchange text based \gls{XML} messages of variable lengths in both directions, they \emph{chat}.
 \item \emph{Presence}\\ Entities can determine other entities' online status if they agreed on that beforehand; therefore, they know each other's presence, e.\,g.\ \emph{offline}, \emph{online}, \emph{absent}, or \emph{busy}.\label{basics:presence}
 \item \emph{Protocol}\\ Entities adhere to a set of rules and regulations that determine how data is transmitted.
\end{description}
Entities can be clients,
servers,
or individual services/resources.
For details see \cref{sec:xmpp-details}.


\section{Internet standard}
Today,
\gls{XMPP} is the primary internet standard for \acrfull{IM} around the world.
It is standardized by the \gls{IETF} with support from the \gls{XSF} in \gls{RFC} 6120~\cite{rfc:6120},
6121~\cite{rfc:6121},
7395~\cite{rfc:7395},
7590~\cite{rfc:7590},
and 7622~\cite{rfc:7622}.
Being an established internet standard means that it is stable,
useful,
mature,
and able to be implemented by anyone with interoperability ensured.
As an internet standard,
it can also be expected that \gls{XMPP} will not change dramatically in the future.
In order to still be able to adapt to changes in modern internet technologies and procedures
and to cater for new and unforeseen requirements,
\gls{XMPP} is extensible by design.


\section{History}
Before \gls{XMPP} became an internet standard it was called \emph{Jabber},
a colloquial name that is still quite popular.
The early Jabber protocol was developed by an open-source community from 1998 to 2000.
In August 2001 the \acrfull{JSF} was founded,
which was renamed to \acrfull{XSF} in January 2007.
Since its inception the \gls{XSF} has assumed responsibility for managing the evolution of the Jabber/\gls{XMPP} protocols in two ways:
\begin{enumerate}
 \item Together with the \gls{IETF} the Jabber core protocols were standardized under the name \gls{XMPP}.
 \item They implemented a process for developing \acrfull{XEP} specifications, that process itself being the first \gls{XEP} ever: \gls{XEP}-0001~\cite{xep:0001}.
\end{enumerate}
Through this work the \gls{XSF} has become the authoritative body for \gls{XMPP} extensions.
A more detailed description regarding the history of Jabber,
\gls{XMPP},
and the roles of the \gls{XSF} and the \gls{IETF} can be found in the respective
\glspl{RFC} and on the \gls{XSF}'s homepage\footnote{\url{https://xmpp.org/about/history}}.


\section{Areas of application today}
The original transport mechanism for \gls{XMPP} is via open-ended \gls{XML} streams over long-lived \gls{TCP} connections.
As an alternative to the basic \gls{TCP} transport mechanism,
the \gls{XMPP} community has developed another one that uses \gls{HTTP} instead, called \emph{\gls{BOSH}}.
A \gls{HTTP} based transport mechanism is especially useful for web clients and users behind restricted firewalls
that only allow \gls{HTTP}(S) connections to go through.
\gls{BOSH} is already quite old though,
the corresponding \gls{XEP}-0206 was first published in 2003~\cite{xep:0206}.
A newer and more efficient \gls{HTTP} based transport for real-time messaging is WebSocket,
a web technology providing for bi-directional,
full-duplex communication channels over a single long-lived \gls{HTTP}(S) connection.
\gls{XMPP} over WebSocket is defined in the \gls{IETF} proposed standard \gls{RFC}~7395~\cite{rfc:7395}.
Having all these different transport mechanisms available allows \gls{XMPP} to be integrated in almost every possible
scenario\footnote{XMPP transport mechanisms are not to be confused with XMPP \emph{Transports},
which are explained in \cref{apx:transports}.}.

Nowadays,
\gls{XMPP} is used inconspicuously inside many software products and it is impossible to gather a complete list of \gls{XMPP} applications.
To the general public,
\gls{XMPP} (or Jabber) is still mostly unknown.
In most cases,
\gls{XMPP} is completely integrated into software / services from specific vendors,
turning it invisible to the outside world by allowing only the vendor's own applications to access it.
A simple example is the BBC News app for iOS and Android devices
where the actual news are transported via \gls{XMPP}.
The same can be said for the BBC Radio website that uses \gls{XMPP} for its LiveText feature\footnote{\url{https://www.process-one.net/en/customers/case\_studies}}.

The following subsections give a rough summary of the \gls{XMPP} usage today.

\subsection{Instant Messaging}
\gls{IM} has always been and still is the primary usage of \gls{XMPP} today.
There is quite a list of client and server software on the \gls{XSF}'s homepage\footnote{\url{https://xmpp.org/software}},
both free and proprietary.
Due to a profit driven economy where financial gain is far more important than interoperability,
\gls{XMPP}'s support for federation has stayed far behind its potential.
Google has replaced its Google Talk client (which supported \gls{XMPP}) with Google Hangouts (which does not\footnote{The Google Talk servers are still online and usable with other XMPP clients though. Simply generate an app password and enter the credentials in any XMPP client,
but beware that Google Talk servers do not support encryption.}).
Facebook has removed their \gls{XMPP} chat interface and replaced it with their Platform API v2.0\footnote{\url{https://developers.facebook.com/docs/chat}}.
WhatsApp has never been an open system,
but in the beginning it was completely based on \gls{XMPP}\footnote{\url{http://highscalability.com/blog/2014/2/26/the-whatsapp-architecture-facebook-bought-for-19-billion.html}}.
Although it is now using an internally developed protocol called \emph{FunXMPP},
that protocol is still based on \gls{XMPP}\footnote{\url{https://github.com/mgp25/Chat-API/wiki/FunXMPP-Protocol}}.
Other popular messaging solutions based on \gls{XMPP} are \href{https://www.chaatz.com}{Chaatz},
\href{https://www.libon.com/}{Libon},
and \href{http://www.rookidsapp.com}{Roo Kids}.
Popular team communication tools like \href{https://slack.com/}{Slack},
\href{https://about.mattermost.com/}{Mattermost},
or \href{https://www.hipchat.com/}{HipChat} have at least some kind of \gls{XMPP} gateway,
so users as well as developers have a standardized interface to use with their own software.

There is also a wide network of private and public servers out there which are running pure,
real \gls{XMPP} with proper federation functionalities.
There are lists of public \gls{XMPP} servers at \href{https://list.jabber.at}{list.jabber.at} and
\href{https://xmpp.net/directory.php}{xmpp.net}.
Additionally,
the ''Recent \acrshort{XMPP} \acrshort{TLS} reports'' at xmpp.net give an idea
how many more non-public servers are out there.
Non-public \gls{XMPP} servers are common for universities,
companies,
and all sorts of organizations who do not want sensitive messages to leave their own servers more than necessary.
It is up to the operator to decide whether an \gls{XMPP} server should have access to (and be accessible from) the \gls{XMPP} network or not.

\subsection{Social web}
There are several web based \gls{XMPP} \gls{IM} clients that go a few steps further and add social features like microblogging,
sharing news posts,
and having the posts of one's friends displayed in a news feed.
All of this can be done within the \gls{XMPP} standard by utilizing certain \glspl{XEP} like Publish-Subscribe (XEP-0060) or Personal Eventing (XEP-0163),
see \cref{sec:xeps} for descriptions.
Examples for such extended \gls{IM} clients are \href{https://movim.eu}{Movim},
\href{https://github.com/jappix}{jappix},
and \href{https://salut-a-toi.org}{Salut à Toi}.

\subsection{Real-time communication}
In the past years,
\gls{RTC},
i.\,e.\ digital audio and video telephony,
has become more and more popular.
\gls{XMPP} is part of a collection of communication protocols and application programming interfaces known as \gls{WebRTC}
which is being standardized by the \gls{W3C} and the \gls{IETF}.
\gls{WebRTC} is a combination of digital audio,
video,
and \gls{IM} communication.
Many \gls{IM} services like WhatsApp or Facebook have added audio and/or video telephony to their portfolio.
Also,
existing audio and video telephony providers added \gls{IM} functionality to their products,
often leveraging \gls{XMPP} for the task.
Examples are \href{https://www.io.swisscom.ch}{Swisscom iO},
\href{https://www.nimbuzz.com}{Nimbuzz!},
\href{https://www.oovoo.com}{ooVoo},
and \href{https://www.wowapp.com}{WowApp}.
The examples with the biggest impact are SIPphone,
acquired by Google\footnote{\url{http://mrblog.org/2011/03/04/closing-of-gizmo5-sipphone-a-sad-day-for-open-standards-voip}} in 2009,
and Jabber~Inc.,
acquired by Cisco\footnote{\url{https://www.cisco.com/c/en/us/about/open-source/jabber.html}} in 2008.
Since then,
Cisco has been offering a proprietary \gls{XMPP} server and has integrated \gls{XMPP} heavily into their \gls{VOIP} products\footnote{\url{https://www.cisco.com/c/en/us/about/corporate-strategy-office/acquisitions/jabberinc.html}}.
Microsoft Lync (now called \emph{Skype for Business} after Microsoft acquired Skype) supports \gls{XMPP} as
well\footnote{\url{https://technet.microsoft.com/en-us/library/jj204825(v=ocs.15).aspx}}.

\gls{XMPP} is also the de facto standard for private chat in gaming related platforms such as
\href{https://www.origin.com}{Origin},
\href{https://raptr.com}{Raptr},
\href{https://www.playstation.com}{PlayStation},
or Riot Games' \href{https://leagueoflegends.com}{League of Legends}.
Web browser based gaming websites also deploy \gls{XMPP},
for example \href{https://www.faceit.com}{FACEIT} or \href{https://www.kixeye.com}{KIXEYE}\footnote{\url{https://github.com/Kixeye/kixmpp}}.

Last but not least there are customer support tools like
\href{https://www.cobrowser.net}{cobrowser}\footnote{\url{https://github.com/Cobrowser/xmpp-prebind-php}},
\href{http://www.iadvize.com}{iAdvize},
or \href{https://livehelperchat.com}{live~helper~chat}\footnote{\url{https://livehelperchat.com/xmp-gtalk-xabber-configuration-and-support-222a.html}}
where employees render support for their customers remotely in real-time with the help of \gls{XMPP}.
BBC News reports:
''German airline Lufthansa has turned to an \gls{XMPP}-based service for its high-value customers. The technology lies behind an instant messaging application that it provides to its most frequent flyers.''\footnote{\url{http://www.bbc.com/news/10113975}}

\subsection{Internet of Things}
\gls{XMPP} already powered the \gls{IoT} before the name \gls{IoT} was invented.
Already in 2008 it powered the community of Nabaztags\footnote{\url{https://blog.process-one.net/build-awesome-internet-of-things-with-processone}},
in 2010 Kodak deployed an \gls{XMPP}-based connection back-end for several series of Kodak digital frames\footnote{\url{https://www.process-one.net/en/customers/case/6270}}.

So far there are still no common standards for the \gls{IoT}.
While standardization organizations are trying to sort things out,
manufacturers of \gls{IoT} devices have to produce now and in most cases simply use the cheapest available software suitable for the task at hand.
That is why the \gls{IoT} is currently facing severe security problems.

\gls{XMPP} on the other side is a sophisticated yet lightweight,
secure,
and scalable choice for \gls{IP} capable \gls{IoT} devices.
To support that notion,
the \gls{XSF} has formed a \gls{SIG} for the \gls{IoT} and has published several experimental \glspl{XEP} regarding the \gls{IoT}.
There is even a dedicated website\footnote{\url{http://www.xmpp-iot.org}}.

Examples for already existing \gls{XMPP}-\gls{IoT} implementations are smart transducer interfaces via the \acrshort{IEEE} \gls{XMPP} Interface Working Group\footnote{\url{http://standards.ieee.org/develop/wg/XMPPI.html}} and demand-response systems for power grids via the OpenADR Alliance\footnote{\url{http://www.openadr.org}}.
OpenADR 2.0 is an internationally recognized standard for \gls{ADR}.
It defines two possible transport mechanisms: \gls{HTTP} and \gls{XMPP}.
A basic two-tier architecture using \gls{XMPP} is shown in \cref{fig:openadr}.
This and other possible deployment scenarios are discussed in detail in~\cite{ieee:openadr_deployment_arches}.

\begin{figure}[htbp]
 \centering
 \includegraphics[width=1\textwidth]{drawings/openadr}
 \captionsetup{width=0.7\textwidth}
 \caption[XMPP in OpenADR 2.0]{Basic two-tier architecture of OpenADR 2.0 in Push-Mode with XMPP as described in~\cite{ieee:openadr_deployment_arches}}
 \label{fig:openadr}
\end{figure}

\subsection{Message-oriented Middleware}
\label{ssec:mom}
This is a somewhat vague term that partially applies to most application areas mentioned before.
It bundles all situations where another application is used on top of \gls{XMPP},
hence \gls{XMPP} being the middleware.

The most prominent use case is probably \gls{GCM} and its successor \gls{FCM},
Google's services for bi-directional Push Notifications to and from Android devices as well as Chrome web browsers.
Google chose to use \gls{XMPP} in order to allow developers to keep a persistent connection between their servers and the \gls{GCM}/\gls{FCM} servers
and to allow the devices to send back notifications to the developers' servers via the \gls{GCM}/\gls{FCM}
servers\footnote{\url{https://developers.google.com/cloud-messaging/ccs}}.

Another good example is \href{http://archipelproject.org}{Archipel},
which uses \gls{XMPP} communication to manage and supervise virtual machines.
See \cref{fig:archipel} for a schematic.

\begin{figure}[htbp]
 \centering
 \includegraphics[width=13cm]{screenshots/archipel}
 \captionsetup{width=0.65\textwidth}
 \caption[XMPP in Archipel]{Schematic of Archipel's architecture,
	 from \url{http://archipelproject.org}}
 \label{fig:archipel}
\end{figure}

From an electrical engineering point of view,
the most exciting use cases for \gls{XMPP} are Smart Grid systems where
\textcquote{iec:61850.1}{XMPP has been introduced in the current committee draft (CD) of \gls{IEC} 61850-8-2 as a network layer,
as its adoption solves the reachability of the system participants.}
\textcquote{iec:61850.2}{This new transport mechanism and encoding will be used between all kinds of utility Distributed Energy Resource devices and related power management systems,
over any communication infrastructure including public networks.}\\
A schematic can be found in \cref{fig:xmpp-iec}.\\

\begin{figure}[htbp]
 \centering
 \includegraphics[width=13cm]{drawings/iec61850}
 \captionsetup{width=0.65\textwidth}
 \caption[XMPP in IEC 61850-8-2]{XMPP in \acrshort{IEC} 61850-8-2, based on \cite{iec:61850.1}}
 \label{fig:xmpp-iec}
\end{figure}

Further examples for \gls{XMPP} as message-oriented middleware:
\begin{itemize}
 \item Apache Wave (formerly Google Wave: a distributed, near real-time, rich collaboration platform) provides federation using an extension of \gls{XMPP}, the open Wave Federation Protocol\footnote{\url{https://incubator.apache.org/wave/about.html}}
 \item IBM has published a tutorial how to build a web-based notification tool with \gls{XMPP}\footnote{\url{http://www.ibm.com/developerworks}}
 \item Isode Limited states on their website,
	 that ''\gls{XMPP} is being increasingly adopted by NATO and National organizations''\footnote{\url{http://www.isode.com/solutions/military-xmpp.html}},
	 and shows a schematic similar to \cref{fig:military-xmpp} to illustrate it
\end{itemize}

\vspace{1cm}

\begin{figure}[htbp]
 \centering
 \includegraphics[width=1\textwidth]{drawings/military-xmpp}
 \captionsetup{width=0.7\textwidth}
 \caption[XMPP in Military Instant Messaging]{Military Instant Messaging, based on
	 \url{http://www.isode.com/solutions/military-xmpp.html}}
 \label{fig:military-xmpp}
\end{figure}

\clearpage

\section{XMPP basics in detail}
\label{sec:xmpp-details}
\gls{XMPP} is based on exchanging \gls{XML} stanzas via \gls{XML} streams,
usually (but not necessarily) transported via \gls{TCP} connections over \gls{IP}.
This is usually implemented as a client-server architecture wherein a client utilizing \gls{XMPP} accesses a server
over a \gls{TCP} connection and servers also communicate with each other over \gls{TCP} connections.
Entities in \gls{XMPP} are uniquely addressed through \glspl{JID}.
The following subsections are intended as an introduction to \gls{XMPP}.
More detailed explanations can be found in the respective \glspl{RFC} which are quite extensive and should cover any questions that might arise.

\subsection{XML streams and XML stanzas}
Two key concepts enable the fast exchange of relatively small amounts of structured data in \gls{XMPP}:
\gls{XML} streams and \gls{XML} stanzas,
as defined in chapter~4 of \gls{RFC}~6120~\cite{rfc:6120}.
To understand \gls{XMPP} it is important to know what these are.

\paragraph{XML stanzas}
are \acrfull{XML} formatted messages which form the basic unit of meaning in \gls{XMPP}.
A stanza's name is either \emph{message},
\emph{presence},
or \emph{iq} and its qualifying namespace is
either \emph{jabber:client} or \emph{jabber:server}.
An \gls{XML} stanza typically contains one or more child elements in order to convey the desired information.

\paragraph{XML streams}
are containers for the exchange of \gls{XML} stanzas between any two \gls{XMPP} entities.
The receiving entity is usually a server while the initiating entity is typically a client or another server.
The initial stream must be negotiated from the initiating entity to the receiving entity before the initiating entity may send an unbounded number of \gls{XML} stanzas.
The initial stream only enables unidirectional communication,
to enable the bidirectional exchange of \gls{XML} stanzas another stream in the opposite direction must be negotiated.
Once the initial \gls{XML} stream is set up,
\gls{XML} stanzas may be used to negotiate further aspects of the stream.

\gls{XML} streams are not the same as connections,
they are one layer above.
Usually,
a single connection carries a single stream in one direction or two streams in opposite directions.
When a connection is lost and a new one is established,
it is possible to resume the streams from the previous connection and resend lost stanzas.~\cite{xep:0198}

\subsection{JIDs}
\label{ssec:jids}
A \acrfull{JID} as defined by \gls{RFC}~7622~\cite{rfc:7622} consists of three parts:
domainpart,
localpart,
and resourcepart.
The domainpart refers to the server,
the localpart to a specific user,
and the resourcepart to a specific client.
These three parts together form a full \gls{JID} of the form \emph{localpart@domainpart/resourcepart},
e.\,g.\ philipp.huebner@jabber.rwth-aachen.de/laptop.

Every \gls{JID} must be unique,
hence a user that wants to be online with several clients at the same time
(e.\,g.\ on a desktop client and on a mobile phone) needs a different resourcepart on each client.
Although the resourcepart can be chosen freely by the user,
not all clients implement that free choice.
Some clients offer a limited selection,
others generate a unique resourcepart by themselves or request to be assigned a unique resourcepart from the server.
\gls{XMPP} servers are required by RFC~6120~\cite{rfc:6120} to hand out random,
unique resourceparts upon request from a client.
The resourcepart enables servers and other clients to handle the individual clients differently,
depending e.\,g.\ on their priority,
presence status,
or supported \glspl{XEP}.
The localpart can be chosen freely upon registration under the condition that it must be unique on that server.
However,
server operators might introduce restrictions on the choice of localparts.
The choice of domainparts is predefined by the chosen server,
as the server can only offer domainparts for domains hosted on that server.

\subsection{Servers}
The word \emph{server} has a multitude of meanings.
Sometimes it describes a physical machine,
sometimes a service running on a physical or virtual machine and
sometimes it refers to a specific domain served by a service or machine that hosts multiple domains.
In this thesis,
\emph{server} refers to the (virtual) machine hosting the \gls{XMPP} service.

A single \gls{XMPP} domain can be operated by multiple servers in a cluster and a single server can operate multiple \gls{XMPP} domains.
In the most simple case a single server hosts a single \gls{XMPP} domain.
\gls{XMPP} servers have \glspl{JID} consisting of only the domainpart for each \gls{XMPP} domain they serve
(e.\,g.\ \emph{jabber.rwth-aachen.de})
so they can exchange \gls{XML} stanzas over \gls{XML} streams with other servers as well as with their clients.
Additional services offered on that \gls{XMPP} server utilize subdomains to have unique server \glspl{JID}
(e.\,g.\ \emph{proxy.jabber.rwth-aachen.de} or \emph{search.jabber.rwth-aachen.de}).

When at least one of its clients sends a message to a \gls{JID} on a remote server,
the local server initiates an outgoing \gls{s2s} connection to the remote server.
\gls{IP} address and port of the remote server are determined through \gls{SRV} record lookups,
explained in \cref{ssec:srv-records}.
In case the \gls{SRV} record lookups fail there is a fallback onto A (or AAAA) record lookups
for \glspl{IP} with default port numbers.
Once the outgoing \gls{s2s} connection is established,
the local server can create \gls{XML} streams to the remote server.
To receive \gls{XML} streams from the remote server,
the same process is run from the remote server's point of view,
establishing an outgoing \gls{s2s} connection to the local server.

In conclusion,
an exchange of \gls{XML} streams between two servers requires two connections,
one for each direction\footnote{There is \gls{XEP}-0288: \emph{Bidirectional Server-to-Server Connections}
where only one \gls{s2s} connection would be needed,
but hardly any \gls{XMPP} server implements that.~\cite{xep:0288}}.

\subsection{Clients}
Clients are software applications connecting to one or several servers in order to participate in the \gls{XMPP} network.
They require full \glspl{JID} as described in \cref{ssec:jids}.
The client takes the domainpart of its configured \glspl{JID} and executes a \gls{SRV} request lookup for each of them.
In case the \gls{SRV} record lookups fail there is a fallback onto A (or AAAA) record lookups
for \glspl{IP} with default port numbers.

After the \gls{IP} and connection port have been found
the client establishes a \gls{c2s} connection,
identifying itself with its full \gls{JID}.
In contrast to \gls{s2s} connections,
\gls{c2s} connections are bidirectional.
The reason behind this different approach is the way the internet has developed:
while servers usually have public \glspl{IP} and can directly reach each other,
clients are often behind \acrshort{NAT}-enabled routers or firewalls,
thus making it impossible for a server to create a new direct connection to a client.
Once the \gls{c2s} connection is established,
the local server and the client are able to set up \gls{XML} streams and exchange \gls{XML} stanzas.

\subsection{Roster, Presence and Subscription}
In \gls{XMPP},
a roster as specified in \gls{RFC}~6121~\cite{rfc:6121} is a set of specific contacts,
i.\,e.\ a structured list of \glspl{JID},
optionally sorted into groups.
Each user has such a personal roster on the server,
usually displayed by a client as the user's contact list that also shows the contacts' presence (if authorized).
Two examples are shown in \cref{fig:xmpp-roster}.

\begin{figure}[htbp]
 \centering
 \raisebox{-0.5\height}{\includegraphics[height=14cm]{screenshots/gajim_roster}}
 \hspace{1cm}
 \raisebox{-0.5\height}{\frame{\includegraphics[height=12cm]{screenshots/conversations_roster}}}
 \caption[XMPP rosters in Gajim and Conversations]{left: roster in Gajim; right: roster in Conversations (anonymized)}
 \label{fig:xmpp-roster}
\end{figure}

The term \emph{presence} has already been introduced at the start of this chapter (on \cpageref{basics:presence}).
A user can only see another user's presence if he is subscribed to it,
which the other user may authorize or deny upon request.
Typically this process is as follows:
\begin{itemize}[itemsep=0pt]
 \item A adds B's \gls{JID} to its roster
 \item this triggers a request for presence subscription from A to B
 \item B receives the request, see \cref{fig:xmpp-subscribe-request} for an example
 \item case 1: B authorizes A's request and adds A's \gls{JID} to its own roster
 \begin{itemize}[noitemsep,label=\textrightarrow]
  \item this triggers a request for presence subscription from B to A
  \item A receives a confirmation for its request as well as the request for its own presence,
         similar to \cref{fig:xmpp-subscribe-request}
  \item A authorizes B's request
  \item B receives a confirmation for its request
  \item A and B have each other in their rosters and can see each other's presence,
	 i.\,e.\ they are subscribed to each other
 \end{itemize}
 \item case 2: B denies A's request
 \begin{itemize}[noitemsep,label=\textrightarrow]
  \item nothing else happens
  \item A has B in its roster but cannot see B's presence
  \item B does not have A in its roster at all
 \end{itemize}
\end{itemize}

\begin{figure}[htbp]
 \centering
 \includegraphics[width=1\textwidth]{screenshots/psi_subscribe_request}
 \caption{XMPP subscription request in Psi+}
 \label{fig:xmpp-subscribe-request}
\end{figure}

\subsection{SRV-Records}
\label{ssec:srv-records}
\Gls{SRV} \glspl{RR} are one of various types of \glspl{RR},
the basic information elements of the \gls{DNS}.
\Gls{DNS} provides a way to resolve \gls{IP} addresses to (sub)domain names and vice versa.

\Gls{SRV} \glspl{RR} specify the location of the server(s) for a specific protocol and domain,
allowing those servers to host individual services for domains that are otherwise not theirs.
\GLS{SRV} \glspl{RR} are similar to \gls{MX} \glspl{RR} which allow for example \mbox{\emph{mx1.rz.rwth-aachen.de}} to handle e-mail services for \mbox{\emph{*@rwth-aachen.de}},
but \gls{SRV} \glspl{RR} are more powerful than \gls{MX} \glspl{RR} as they additionally specify what protocol and what port to use.
\gls{XMPP} \gls{s2s} ports are looked up by \mbox{\emph{\_xmpp-server.\_tcp.<domain>}},
\gls{XMPP} \gls{c2s} ports by \mbox{\emph{\_xmpp-client.\_tcp.<domain>}}.
Here is an example:

\begin{verbatim}
_xmpp-server._tcp.jabber.at. 3600 IN  SRV  300 0 5269 xmpp.jabber.at.
_xmpp-client._tcp.jabber.at. 3600 IN  SRV  300 0 5222 xmpp.jabber.at.
_xmpp-client._tcp.jabber.at. 3600 IN  SRV  600 0 443 xmpp.jabber.at.
\end{verbatim}
The fields above have the following meanings:
\begin{itemize}[itemsep=0pt]
 \item \emph{\_xmpp-server. / \_xmpp-client.} \textrightarrow~the service being offered, in this case \gls{XMPP} \gls{s2s} and \gls{XMPP} \gls{c2s}
 \item \emph{\_tcp.} \textrightarrow~the protocol to use, here \gls{TCP}
 \item \emph{jabber.at.} \textrightarrow~the domainpart of the \gls{JID}
 \item \emph{3600} \textrightarrow~the \gls{TTL} in seconds
 \item \emph{IN} \textrightarrow~the \gls{DNS} class
 \item \emph{300 / 600} \textrightarrow~the priority for this \gls{RR}, a lower value means higher priority with zero being the highest priority
 \item \emph{0} \textrightarrow~the weight for this \gls{RR}, used if several \glspl{RR} have the same priority
 \item \emph{5269 / 5222 / 443} \textrightarrow~the port to use
 \item \emph{xmpp.jabber.at.} \textrightarrow~the target host to connect to
\end{itemize}
Consequently,
other servers trying to reach jabber.at would connect to xmpp.jabber.at on port 5269.
Clients would first try a connection to xmpp.jabber.at on port 5222 and if that fails try a connection to xmpp.jabber.at on port 443.
This is useful for clients behind firewalls that only allow the outgoing \gls{HTTPS} port 443.
However,
having an \gls{XMPP} server occupying the \gls{HTTPS} port makes it difficult to offer a secured website on the same host.
Thanks to \gls{SRV} \glspl{RR},
you can reach the website of jabber.at on a different host than the \gls{XMPP} server for the same domain.

Further details regarding the usage of \gls{SRV} \glspl{RR} in \gls{XMPP} can be obtained from \gls{RFC}~2782~\cite{rfc:2782} and 6120~\cite{rfc:6120}.

\subsection{Network structure}
The previous subsections together describe a distributed and federated network as shown in \cref{fig:xmpp-network}.
It is distributed because all servers have equal rank and no server has a key role that would put it above any other.
It is federated because every server is only responsible for a fixed set of domains while messages sent to \glspl{JID} on foreign domains are forwarded to the appropriate servers.

\vspace{1cm}

\begin{figure}[htbp]
 \bigskip
 \includegraphics[width=1\textwidth]{drawings/federated-network}
 \caption[XMPP network graph]{Distributed and federated XMPP network}
 \label{fig:xmpp-network}
\end{figure}

\clearpage

\section{XMPP Extension Protocols (XEPs)}
\label{sec:xeps}
\glspl{XEP} greatly improve the \gls{XMPP} core functionality by introducing new features.
The current list of all \textasciitilde200 active \glspl{XEP} and their statuses can be found on the \gls{XSF}'s
homepage\footnote{\url{https://xmpp.org/extensions}}.
Implementing these \glspl{XEP} in any \gls{XMPP} software is completely optional,
albeit many of them are very useful and their implementation is definitely recommended,
see \gls{XEP}-0387 (\emph{XMPP Compliance Suites 2017}).

The following paragraphs list several of the most important \glspl{XEP} for a modern \gls{XMPP} system targeting human users and give a short description.
For more in-depth reading it is recommended to read the actual \glspl{XEP}.
The \glspl{XEP} are well formulated for easy comprehension,
they usually have an introduction and one or more use cases describing their purpose in an intelligible way.

\paragraph{XEP-0013: Flexible Offline Message Retrieval}
enables servers to store messages for users that are currently offline.
The next client the user goes online with will fetch the stored messages
which removes them from the server.~\cite{xep:0013}

\paragraph{XEP-0030: Service Discovery}
allows discovering two kinds of information about other \gls{XMPP} entities:
\begin{enumerate}[noitemsep]
 \item the identity and capabilities of an entity along with the features it supports (e.\,g.\ other \glspl{XEP})
 \item the items associated with an entity (e.\,g.\ the list of rooms hosted at a multi-user chat service)
\end{enumerate}
Service Discovery can be used automatically by client or server applications as well as manually by a user.
Two examples for manual Service Discovery are shown in figs.~\ref{fig:xmpp-disco-gajim} and~\ref{fig:xmpp-disco-psi}.~\cite{xep:0030}

\begin{figure}[htb]
 \centering
 \includegraphics[width=1\textwidth]{screenshots/gajim_disco}
 \caption{Service Discovery (XEP-0030) in Gajim}
 \label{fig:xmpp-disco-gajim}
\end{figure}

\begin{figure}[htbp]
 \centering
 \includegraphics[width=1\textwidth]{screenshots/psi_disco}
 \caption{Service Discovery (XEP-0030) in Psi+}
 \label{fig:xmpp-disco-psi}
\end{figure}

\paragraph{XEP-0045: Multi-User Chat (MUC)}
introduces the well-known feature of chat rooms where multiple users participate in a common chat.
These \glspl{MUC} can have names,
topics,
subjects,
and more.
It is quite similar to \gls{IRC},
only with many more features.
Additionally,
\gls{XEP}-0045 defines long-lived affiliations (\emph{owner},
\emph{admin},
\emph{member},
\emph{outcast},
or \emph{none})
and session-specific roles (\emph{moderator},
\emph{participant},
\emph{visitor},
or \emph{none}) and their corresponding rights.
This \gls{XEP} specifies the basic functionality,
other \glspl{XEP} supply additional features to \glspl{MUC}.
See figs.~\ref{fig:xmpp-muc-gajim} and~\ref{fig:xmpp-muc-conversations} for examples of public \glspl{MUC} in clients implementing this \gls{XEP}.~\cite{xep:0045}

\begin{figure}[htbp]
 \centering
 \includegraphics[width=1\textwidth]{screenshots/gajim_muc}
 \caption[Multi-User Chat (XEP-0045) in Gajim]{A public Multi-User Chat (XEP-0045) in Gajim}
 \label{fig:xmpp-muc-gajim}
\end{figure}

\begin{figure}[htbp]
 \centering
 \smallskip
 {\frame{\includegraphics[height=12cm]{screenshots/conversations_muc}}}
 \caption[Multi-User Chat (XEP-0045) in Conversations]{A public Multi-User Chat (XEP-0045) in Conversations}
 \label{fig:xmpp-muc-conversations}
\end{figure}

\paragraph{XEP-0047: In-Band Bytestreams}
enables any two entities to establish a one-to-one bytestream between themselves,
where the data is broken down into smaller Base64-encoded chunks and transported in-band over \gls{XMPP}.
It is a generic bytestream transport protocol which can be used by an application in many ways,
although it is mostly used as a fallback method for sending files.~\cite{xep:0047}

\paragraph{XEP-0060: Publish-Subscribe}
defines generic publish-subscribe functionality which a lot of client side features
as well as other \glspl{XEP} rely upon.
It can be seen as news feeds that any entity can create and other entities can subscribe to.~\cite{xep:0060}

\paragraph{XEP-0065: SOCKS5 Bytestreams}
allows clients to negotiate a bytestream over a separate \gls{TCP} connection,
either directly or via a proxy.
Most \gls{XMPP} servers can be configured to also act as such file transfer proxies (including authentication);
therefore no additional software is necessary.
These out-of-band bytestreams as opposed to in-band bytestreams from \gls{XEP}-0047 have a much better performance most of the time.
While in theory these bytestreams can transport any kind of data,
in reality most clients only use it for sending large files to other users.~\cite{xep:0065}

\paragraph{XEP-0085: Chat State Notifications}
adds notifications about a user's session chat state to the \gls{XML} stream.
The list of possible chat states for a user's session is \emph{active},
\emph{composing},
\emph{paused},
\emph{inactive},
and \emph{gone}.
It is completely up to the user/client whether to send these or not,
but it is quite beneficial for all involved users.
This \gls{XEP} covers both normal and multi-user chats.~\cite{xep:0085}

\paragraph{XEP-0092: Software Version}
allows entities to query other entities for the name of the software application,
the version of the software application,
and the operating system on which the application is running.
Since all \glspl{XEP} are optional,
no entity is forced to reveal any of this information.~\cite{xep:0092}

\paragraph{XEP-0115: Entity Capabilities}
is an extension of \gls{XEP}-0030: Service Discovery.
In the past,
after logging in,
some Jabber clients sent one Service Discovery and one Software Version (\gls{XEP}-0092) request to each entity whose presence they were subscribed to.
This caused quite a flood of \gls{XMPP} traffic for all involved entities.
In order to render such behavior unnecessary, this \gls{XEP} was created.
It does so by adding a short verification string to a client's presence messages.
Every client receiving such a message will execute one Service Discovery request the first time they receive that string.
The result will then be cached persistently for future use.
The verification string is a hash of a client's service discovery identities and is created after specific rules.
It should only change when a client's features have changed.~\cite{xep:0115}

\paragraph{XEP-0163: Personal Eventing Protocol}
defines a simplified subset of Publish-Subscribe (\gls{XEP}-0060)
which is easier to deploy for \gls{XMPP} developers.
It is called \acrfull{PEP} and provides a way for a user to send updates or \emph{events} to other users
who are typically contacts in the user's roster.
Although these events can be anything the user wants to make known to others,
most of them are standardized in other \glspl{XEP}.~\cite{xep:0163}

\paragraph{XEP-0184: Message Delivery Receipts}
defines a mechanism for \gls{XMPP} message delivery receipts.
Senders are able to request delivery receipts for \gls{XML} stanzas and recipients are able to send these.
It is important to know that there is no distinction between delivery and display.
All that this \gls{XEP} does is to ensure that an \gls{XML} stanza has been received by a remote client.~\cite{xep:0184}

\paragraph{XEP-0191: Blocking Command}
gives users the ability to block and unblock communication with selected users (i.\,e.\ \glspl{JID}) on the server side,
meaning that messages from blocked \glspl{JID} are discarded by the server and never delivered to the user.~\cite{xep:0191}

\paragraph{XEP-0198: Stream Management}
supplies tools for actively managing a live XML
stream\footnote{\gls{RFC}~6120~\cite{rfc:6120} only defines the fundamental streaming \gls{XML} technology used by \gls{XMPP}}
which among other things allow for stanza acknowledgements and stream resumption.
These features are crucial for clients on mobile devices which often and irregularly switch between GSM and Wi-Fi networks.
Instead of idle,
dead \gls{XML} streams waiting for a timeout and stanzas being lost,
clients have the ability to resume an interrupted \gls{XML} stream and receive not yet acknowledged stanzas anew.~\cite{xep:0198}

\paragraph{XEP-0220: Server Dialback}
defines the Server Dialback protocol,
which is used to provide identity verification between \gls{XMPP} servers.
In a system that allows federation it is important for a server to be able to determine the identity of a peer server.
Obviously,
strong identity verification is preferred,
typically using digital certificates issued by trusted root certification authorities (CAs) with \gls{TLS}.
However,
if that fails for any reason,
most \gls{XMPP} servers will use this \gls{XEP} as a fallback.

Basically,
a server receiving an incoming \gls{s2s} connection where strong identity verification fails will do the following:
open an outgoing \gls{s2s} connection to the servername claimed by the incoming connection,
then validate that servername against \gls{DNS} by ensuring the outgoing connection has contacted the same server.
See \cref{ssec:srv-records} for information on how \gls{DNS} is used by \gls{XMPP}.
The Server Dialback protocol also ensures that the receiving server is accepting stanzas for the target domain.
For this protocol to function,
both sides must support it.

The \gls{XEP} states:
\textcquote{xep:0220}{Although Server Dialback does not provide strong authentication and is subject to \gls{DNS} poisoning attacks,
it has effectively prevented most address spoofing on the \gls{XMPP} network since its development in the year 2000.}

\paragraph{XEP-0237: Roster Versioning}
has actually been declared obsolete by the \gls{XSF},
but only because it is so important that it has been incorporated into \gls{RFC}~6121~\cite{rfc:6121}.
A user's \emph{roster} is his contact list,
i.\,e.\ a list of \glspl{JID} with their corresponding states of presence subscription.
\emph{Versioning} of roster information allows clients to cache the roster so they only need to download the roster
when a newer version is available\footnote{instead of downloading the whole roster on every (re-)connection},
effectively saving bandwidth and speeding up the login process.~\cite{xep:0237}

\paragraph{XEP-0280: Message Carbons}
causes copies of messages to be sent to all other resources of the user sending or receiving the original ones.
That way,
if a user is online with more than one client simultaneously,
every client will have the full conversation and the user can switch clients at will.~\cite{xep:0280}

For complete message synchronization between clients that are not online all the time,
see \gls{XEP}-0313.~\cite{xep:0313}

\paragraph{XEP-0313: Message Archive Management}
adds a server-side message store to \gls{XMPP},
facilitating full message history synchronization between all clients supporting this protocol.
This feature enables users to have the same complete message history available in all clients,
but requires the messages to be stored centrally on the server.
To prevent potential privacy leaks,
users have the ability to switch this feature on and off at will.~\cite{xep:0313}

\paragraph{XEP-0333: Chat Markers}
informs the opposite party up to which point received messages have been displayed to the user.
In a way,
this \gls{XEP} continues where \mbox{\gls{XEP}-0184} \emph{Message Delivery Receipts} has left off.~\cite{xep:0333}

\paragraph{XEP-0352: Client State Indication}
is targeted at clients that are always online,
but not always actively used,
e.\,g.\ a client on a mobile phone where the screen is switched of.
By indicating this state to the server,
the server can reduce traffic a lot by withholding all information that is currently irrelevant to the user.
When the screen is turned off,
the user does not need to know the current presence,
chat state,
and similar information about other users.
As soon as the screen is turned on again,
the client can indicate that change to the server which will then send only the most current state of all information it has withheld.~\cite{xep:0352}

\paragraph{XEP-0357: Push Notifications}
is especially important for modern releases of Android and iOS.
To conserve battery power,
Google/Apple forbid messaging apps to keep mobile devices awake and only allow the server side to wake the phone by using Push Notifications through their platforms.
With \gls{XMPP} this is achieved through a two-tiered push architecture:
the \gls{XMPP} server notifies an app-specific server (e.\,g.\ conversations.im) which in turn notifies the platform-specific services,
e.\,g.\ Google's Cloud Messaging (see \cref{ssec:mom}) or Apple's Push Notification Service.~\cite{xep:0357}

\paragraph{XEP-0363: HTTP File Upload}
\label{xep-0363}
was introduced to overcome the limitations of peer-to-peer file transfers by introducing server-side storage.
Clients can request a so-called slot from their servers and will receive both an upload \gls{URL} to use via \gls{HTTP} upload and a download \gls{URL} they can share with other entities that shall be able to download the file.
This is especially beneficial when sharing files with multiple users or users that use multiple clients and want to have these files accessible in every client.
Together with \gls{XEP}-0313 (Message Archive Management) any client can access the files as long as they are available on the server.
This is mostly used for small files like photos,
but can be used with arbitrary files as long as the server accepts the file size.~\cite{xep:0363}

\paragraph{XEP-0368: SRV records for XMPP over TLS}
extends the use of \gls{SRV} \glspl{RR} as seen on \cpageref{ssec:srv-records},
enabling clients and servers to discover server ports where they must connect with \gls{TLS} enabled,
as opposed to server ports for unencrypted connections with or without StartTLS.~\cite{xep:0368}

\paragraph{XEP-0387: Compliance Suites 2017}
\label{xep-0387}
defines a set of compliance suites for \gls{XMPP} to give people a basis for evaluating the degree of conformity of a certain software with modern \gls{XMPP} standards.
The \gls{XSF} publishes such a \gls{XEP} every few years.
It is also intended as a recommendation for developers,
telling them which of the many \glspl{RFC} and \glspl{XEP} to focus on.
This will be used as a point of reference in chapters~\ref{chap:evaluation} and~\ref{chap:conclusion}.
At the time of writing this thesis,
the newest set of compliance suites is from 2017 and defined in \gls{XEP}-0387.
It defines four different compliance suites:
\emph{Core},
\emph{Web},
\emph{\gls{IM}},
and \emph{Mobile}.
Each compliance suite is subdivided into four compliance levels:
\emph{Core Server},
\emph{Core Client},
\emph{Advanced Server},
and \emph{Advanced Client}.
The compliance levels require different \glspl{RFC} and \glspl{XEP} to be correctly implemented.
Every advanced level includes and extends the requirements of the corresponding core level,
just like all compliance suites include and extend the requirements of the core compliance suite.~\cite{xep:0387}


\section{Additional software}
While \gls{XMPP} with its extensible nature covers a lot of ground,
there are certain reasons to complement an \gls{XMPP} server with a central \gls{HTTP}(S) based website.
The foremost reason is to convey information to users who have not registered an \gls{XMPP} account yet.
Other reasons are to give users the possibility to reset their password in case they lost it or to impose additional restrictions upon the registration process.
It is also reasonable to give the users an alternative way to contact the server administrator(s) in case they cannot access their \gls{XMPP} account for whatever reason.
The approach via a central website is a sensible way to implement these features that otherwise would have to be implemented separately for every client application.\\
A proper website requires several additional software products:
\begin{itemize}[itemsep=0pt]
 \item a web server to offer the actual website via \gls{HTTP}(S)
 \item some sort of \gls{CMS} for not having to write a website from scratch
 \item a \gls{DBMS} for the \gls{CMS}
 \item a \gls{MTA} so the website can send e-mails to users
\end{itemize}
\smallskip
In case of jabber.rwth-aachen.de it is necessary to present the \gls{GTC} for using the server,
to verify that users have access to an e-mail address from one of the Aachen universities before they register an account,
and to have them solve a captcha to prevent bots from registering accounts for spam purposes.
Should the \gls{XMPP} service become unavailable at some point,
the website is a good way to inform the users in an unobtrusive way.
Likewise,
users can inform the administrators about the outage via a contact form on the website.
A simple example is the homepage of \href{https://www.jabber.org}{jabber.org},
see \cref{fig:hp-jabber-org}.

A central website would also be a good place for users to manage shared roster groups (see the end of \cref{chap:introduction} for this secondary goal).
The next chapter will cover the implementation of the new system.

\begin{figure}[htbp]
 \centering
 \rule{1\textwidth}{0.4pt}\\
 \vspace{0.5cm}
 \includegraphics[width=1\textwidth]{screenshots/hp_jabber_org}
 \rule{1\textwidth}{0.4pt}\\
 \caption[Homepage of jabber.org]{Homepage of \href{http://www.jabber.org/}{jabber.org}}
 \label{fig:hp-jabber-org}
\end{figure}
